Name:		fermilab-conf_apache-use-syslog
Version:	1.1
Release:	3.1
Summary:	Change the default httpd.conf to use clogger and local logging

Group:		Fermi
License:	GPL
URL:		http://fermilinux.fnal.gov
Source0:	%{name}.sh
Source1:	001-apache.conf
BuildArch:	noarch
Obsoletes:	zz_apache_use_clogger

Requires(post):	augeas
Requires(post):	coreutils
Requires(post):	systemd
Requires(post):	rsyslog

Requires(preun):	augeas
Requires(preun):	coreutils
Requires(preun):	systemd
Requires(preun):	rsyslog

Requires:	fermilab-conf_system-logger

%description
This package will reconfigure the default /etc/httpd/conf/httpd.conf
to use clogger in addition to the traditional /var/log/httpd/ logging.

We will enable syslog via adding:

ErrorLog "| /usr/bin/logger  -thttpd -plocal6.err"
CustomLog "| /usr/bin/logger  -thttpd -plocal6.notice" combined

This package requires rsyslog configured for Fermilab's central
logging service.

Per: RITM0193644

%prep

%build

%install
rm -rf %{buildroot}
%{__install} -D %{SOURCE0} %{buildroot}/%{_libexecdir}/%{name}/%{name}.sh
%{__install} -D %{SOURCE1} %{buildroot}/%{_sysconfdir}/rsyslog.d/001-apache.conf

%check
bash -n %{buildroot}/%{_libexecdir}/%{name}/%{name}.sh

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,-)
%config /etc/rsyslog.d/*
%attr(0750,root,root) %{_libexecdir}/%{name}/%{name}.sh

%triggerin -p /bin/bash -- httpd
##################### BEGIN Snippet #################################
set -u
TRIGGER_ON_PACKAGE_NAME='httpd'
# The following script snippet attempts to classify why we were called:
#  - on first install of either package, RUN_TRIGGER == "Initial"
#  - on upgrade of _THIS_ package, RUN_TRIGGER == "UpgradeSELF"
#  - on upgrade of the TRIGGERON package, RUN_TRIGGER == "UpgradeTRIGGERON"
#  - on upgrade of the TRIGGERON package but initial install of _THIS_ package, RUN_TRIGGER == "InitialSELFUpgradeTRIGGERON"
#  - on upgrade of the BOTH packages, RUN_TRIGGER == "UPGRADEALL"

CURRENT_INSTALLS_OF_THIS_PACKAGE=${1}
TRIGGER_ON_PACKAGE=${2}

RUN_TRIGGER="NO"
if [[ ${TRIGGER_ON_PACKAGE} -eq 1 ]]; then
    # We only get here if we are NOT doing an upgrade of the trigger package
    if [[ ${CURRENT_INSTALLS_OF_THIS_PACKAGE} -eq 0 ]]; then
        # We only get here if we are removing _THIS_ package
        RUN_TRIGGER="UninstallSELF"
    elif [[ ${CURRENT_INSTALLS_OF_THIS_PACKAGE} -eq 1 ]]; then
        # We only get here if we are NOT doing an upgrade of the trigger package
        #                and we are installing _THIS_ package for the first time
        RUN_TRIGGER="Initial"
    elif [[ ${CURRENT_INSTALLS_OF_THIS_PACKAGE} -gt 1 ]]; then
        # We only get here if we are NOT doing an upgrade of the trigger package
        #                and we are upgrading _THIS_ package
        RUN_TRIGGER="UpgradeSELF"
    fi
elif [[ ${TRIGGER_ON_PACKAGE} -gt 1 ]]; then
    # We only get here if we are doing an upgrade of the trigger package
    if [[ ${CURRENT_INSTALLS_OF_THIS_PACKAGE} -eq 1 ]]; then
        # We get here if we are doing an upgrade of the trigger package
        #                     and we are NOT upgrading _THIS_ package
        RUN_TRIGGER="UpgradeTRIGGERON"

        #  But, are we installing _THIS_ package as a part of a dependency
        #       resolution chain?
        _THIS_TID=$(rpm -q --qf "%{INSTALLTID}\n" %{NAME})
        # Find the last installed (ie the current) TRIGGER_ON_PACKAGE_NAME's transaction
        TID=$(rpm -q --qf "%{INSTALLTID}\n" ${TRIGGER_ON_PACKAGE_NAME} --last |grep -v ${TRIGGER_ON_PACKAGE_NAME} | head -1)
        if [[ "${_THIS_TID}" == "${TID}" ]]; then
            # if the transaction ID of _THIS_ package is identical to the
            #  transaction ID of an installed TRIGGER_ON_PACKAGE_NAME
            # then, we must be upgrading the trigger package and
            # installing _THIS_ package
            RUN_TRIGGER="InitialSELFUpgradeTRIGGERON"
        fi
    elif [[ ${CURRENT_INSTALLS_OF_THIS_PACKAGE} -gt 1 ]]; then
        # We only get here if we are doing an upgrade of the trigger package
        #                     and we are upgrading _THIS_ package
        RUN_TRIGGER="UpgradeALL"
    fi
elif [[ ${TRIGGER_ON_PACKAGE} -eq 0 ]]; then
    # We only get here if we are removing the trigger package
    RUN_TRIGGER="UninstallTRIGGERON"
fi

if [[ "${RUN_TRIGGER}" == "NO" ]]; then
    # If we got here if:
    #  some kind of edge case appeared......
    echo "##################################" >&2
    echo "%{NAME}: Not sure what this means"  >&2
    echo "CURRENT_INSTALLS_OF_THIS_PACKAGE = ${CURRENT_INSTALLS_OF_THIS_PACKAGE}"  >&2
    echo "TRIGGER_ON_PACKAGE (${TRIGGER_ON_PACKAGE_NAME}) = ${TRIGGER_ON_PACKAGE}" >&2
    echo "##################################" >&2
    exit 1
fi

##################### End of Snippet #################################
if [[ "${RUN_TRIGGER}" == "UpgradeTRIGGERON" ]]; then
    # If we got here if:
    #  a) we are upgrading the trigger package, but not _THIS_ package
    #       so we've already run this once and will not run it again.

    # If the user changed the config themselves, we shouldn't undo their work
    #  if we decide we need to, we can always alter the behavior in the next
    #  version of this package.
    exit 0
fi

# # #
# This way external scripts/config tools can call these changes if they want
%{_libexecdir}/%{name}/%{name}.sh setup

systemctl is-enabled rsyslog.service >/dev/null 2>&1
if [[ $? -eq 0 ]]; then
    systemctl condrestart rsyslog.service
fi

systemctl is-enabled httpd.service >/dev/null 2>&1
if [[ $? -eq 0 ]]; then
    systemctl condrestart httpd.service
fi

%preun
%{_libexecdir}/%{name}/%{name}.sh remove
systemctl is-enabled httpd.service >/dev/null 2>&1
if [[ $? -eq 0 ]]; then
    systemctl condrestart httpd.service
fi

systemctl is-enabled rsyslog.service >/dev/null 2>&1
if [[ $? -eq 0 ]]; then
    systemctl condrestart rsyslog.service
fi

%changelog
* Thu Feb 25 2016 Pat Riehecky <riehecky@fnal.gov> 1.1-3.1
- Check to make sure the services are enabled before restarting them

* Wed Nov 11 2015 Pat Riehecky <riehecky@fnal.gov> 1.1-3
- Should just trigger on httpd, not require it

* Wed Nov 11 2015 Kevin M. Hill <kevinh@fnal.gov> 1.1-2
- switch back to using Augeas, just in case.

* Tue Nov 10 2015 Kevin M. Hill <kevinh@fnal.gov> 1.1-1
- Initial SL7 version.

* Wed Jan 30 2013 Pat Riehecky <riehecky@fnal.gov> 1.0-1
- Initial build
